/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef DPC_IMPL_TYPE_LANEMARKERINFO_H
#define DPC_IMPL_TYPE_LANEMARKERINFO_H

#include <cfloat>
#include <cmath>
#include "impl_type_float.h"
#include "impl_type_uint8.h"
#include "dpc/impl_type_array_samplingpoint_25.h"

namespace dpc {
struct LaneMarkerInfo {
    ::Float lane_mkr_c0{ 0.0F };
    ::Float lane_mkr_c1{ 0.0F };
    ::Float lane_mkr_c2{ 0.0F };
    ::Float lane_mkr_c3{ 0.0F };
    ::Float lane_mrk_viewrange{ 0.0F };
    ::UInt8 lane_mkr_typ{ 0U };
    ::Float lane_mkr_existnc_problty{ 0.0F };
    ::dpc::array_SamplingPoint_25 sampling_points{};

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(lane_mkr_c0);
        fun(lane_mkr_c1);
        fun(lane_mkr_c2);
        fun(lane_mkr_c3);
        fun(lane_mrk_viewrange);
        fun(lane_mkr_typ);
        fun(lane_mkr_existnc_problty);
        fun(sampling_points);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(lane_mkr_c0);
        fun(lane_mkr_c1);
        fun(lane_mkr_c2);
        fun(lane_mkr_c3);
        fun(lane_mrk_viewrange);
        fun(lane_mkr_typ);
        fun(lane_mkr_existnc_problty);
        fun(sampling_points);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("lane_mkr_c0", lane_mkr_c0);
        fun("lane_mkr_c1", lane_mkr_c1);
        fun("lane_mkr_c2", lane_mkr_c2);
        fun("lane_mkr_c3", lane_mkr_c3);
        fun("lane_mrk_viewrange", lane_mrk_viewrange);
        fun("lane_mkr_typ", lane_mkr_typ);
        fun("lane_mkr_existnc_problty", lane_mkr_existnc_problty);
        fun("sampling_points", sampling_points);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("lane_mkr_c0", lane_mkr_c0);
        fun("lane_mkr_c1", lane_mkr_c1);
        fun("lane_mkr_c2", lane_mkr_c2);
        fun("lane_mkr_c3", lane_mkr_c3);
        fun("lane_mrk_viewrange", lane_mrk_viewrange);
        fun("lane_mkr_typ", lane_mkr_typ);
        fun("lane_mkr_existnc_problty", lane_mkr_existnc_problty);
        fun("sampling_points", sampling_points);
    }

    friend bool operator==(const ::dpc::LaneMarkerInfo& lhs, const ::dpc::LaneMarkerInfo& rhs) noexcept
    {
        return (fabs(static_cast<double>(lhs.lane_mkr_c0 - rhs.lane_mkr_c0)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lane_mkr_c1 - rhs.lane_mkr_c1)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lane_mkr_c2 - rhs.lane_mkr_c2)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lane_mkr_c3 - rhs.lane_mkr_c3)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.lane_mrk_viewrange - rhs.lane_mrk_viewrange)) < DBL_EPSILON) && (lhs.lane_mkr_typ == rhs.lane_mkr_typ) && (fabs(static_cast<double>(lhs.lane_mkr_existnc_problty - rhs.lane_mkr_existnc_problty)) < DBL_EPSILON) && (lhs.sampling_points == rhs.sampling_points);
    }
};
} // namespace dpc


#endif // DPC_IMPL_TYPE_LANEMARKERINFO_H
