/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef DPC_IMPL_TYPE_LINE_POINT_H
#define DPC_IMPL_TYPE_LINE_POINT_H

#include "dpc/impl_type_position.h"
#include "dpc/impl_type_attribute.h"

namespace dpc {
struct line_point {
    ::dpc::position point;
    ::dpc::attribute point_attri;

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(point);
        fun(point_attri);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(point);
        fun(point_attri);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("point", point);
        fun("point_attri", point_attri);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("point", point);
        fun("point_attri", point_attri);
    }

    friend bool operator==(const ::dpc::line_point& lhs, const ::dpc::line_point& rhs) noexcept
    {
        return (lhs.point == rhs.point) && (lhs.point_attri == rhs.point_attri);
    }
};
} // namespace dpc


#endif // DPC_IMPL_TYPE_LINE_POINT_H
