/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_PHYSICAL_GNSS_SOL_RESULT_COMMON_T_H
#define IMPL_TYPE_PHYSICAL_GNSS_SOL_RESULT_COMMON_T_H

#include "impl_type_uint16.h"
#include "impl_type_uint32.h"
#include "impl_type_uint64.h"
#include "impl_type_uint8.h"

struct physical_gnss_sol_result_common_t {
    ::UInt16 gnss_gps_week{ 0U };
    ::UInt32 gnss_gps_sow{ 0U };
    ::UInt64 timestamp_s{ 0U };
    ::UInt64 timestamp_ns{ 0U };
    ::UInt8 crc8{ 0U };

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(gnss_gps_week);
        fun(gnss_gps_sow);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(gnss_gps_week);
        fun(gnss_gps_sow);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("gnss_gps_week", gnss_gps_week);
        fun("gnss_gps_sow", gnss_gps_sow);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("gnss_gps_week", gnss_gps_week);
        fun("gnss_gps_sow", gnss_gps_sow);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    friend bool operator==(const ::physical_gnss_sol_result_common_t& lhs, const ::physical_gnss_sol_result_common_t& rhs) noexcept
    {
        return (lhs.gnss_gps_week == rhs.gnss_gps_week) && (lhs.gnss_gps_sow == rhs.gnss_gps_sow) && (lhs.timestamp_s == rhs.timestamp_s) && (lhs.timestamp_ns == rhs.timestamp_ns) && (lhs.crc8 == rhs.crc8);
    }
};


#endif // IMPL_TYPE_PHYSICAL_GNSS_SOL_RESULT_COMMON_T_H
