/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_PHYSICAL_GNSS_SOL_RESULT_LONGITUDE_T_H
#define IMPL_TYPE_PHYSICAL_GNSS_SOL_RESULT_LONGITUDE_T_H

#include <cfloat>
#include <cmath>
#include "impl_type_double.h"
#include "impl_type_uint64.h"
#include "impl_type_uint8.h"

struct physical_gnss_sol_result_longitude_t {
    ::Double gnss_longitude{ 0.0 };
    ::Double gnss_longitude_std{ 0.0 };
    ::UInt64 timestamp_s{ 0U };
    ::UInt64 timestamp_ns{ 0U };
    ::UInt8 crc8{ 0U };

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(gnss_longitude);
        fun(gnss_longitude_std);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(gnss_longitude);
        fun(gnss_longitude_std);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("gnss_longitude", gnss_longitude);
        fun("gnss_longitude_std", gnss_longitude_std);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("gnss_longitude", gnss_longitude);
        fun("gnss_longitude_std", gnss_longitude_std);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    friend bool operator==(const ::physical_gnss_sol_result_longitude_t& lhs, const ::physical_gnss_sol_result_longitude_t& rhs) noexcept
    {
        return (fabs(static_cast<double>(lhs.gnss_longitude - rhs.gnss_longitude)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.gnss_longitude_std - rhs.gnss_longitude_std)) < DBL_EPSILON) && (lhs.timestamp_s == rhs.timestamp_s) && (lhs.timestamp_ns == rhs.timestamp_ns) && (lhs.crc8 == rhs.crc8);
    }
};


#endif // IMPL_TYPE_PHYSICAL_GNSS_SOL_RESULT_LONGITUDE_T_H
