/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_PHYSICAL_GNSS_SOL_RESULT_NUM_T_H
#define IMPL_TYPE_PHYSICAL_GNSS_SOL_RESULT_NUM_T_H

#include "impl_type_uint8.h"
#include "impl_type_uint64.h"

struct physical_gnss_sol_result_num_t {
    ::UInt8 gnss_num_sats{ 0U };
    ::UInt8 gnss_num_sats_used{ 0U };
    ::UInt8 gnss_used_snr_avg{ 0U };
    ::UInt8 heading_svs{ 0U };
    ::UInt8 heading_soln_svs{ 0U };
    ::UInt64 timestamp_s{ 0U };
    ::UInt64 timestamp_ns{ 0U };
    ::UInt8 crc8{ 0U };

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(gnss_num_sats);
        fun(gnss_num_sats_used);
        fun(gnss_used_snr_avg);
        fun(heading_svs);
        fun(heading_soln_svs);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(gnss_num_sats);
        fun(gnss_num_sats_used);
        fun(gnss_used_snr_avg);
        fun(heading_svs);
        fun(heading_soln_svs);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("gnss_num_sats", gnss_num_sats);
        fun("gnss_num_sats_used", gnss_num_sats_used);
        fun("gnss_used_snr_avg", gnss_used_snr_avg);
        fun("heading_svs", heading_svs);
        fun("heading_soln_svs", heading_soln_svs);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("gnss_num_sats", gnss_num_sats);
        fun("gnss_num_sats_used", gnss_num_sats_used);
        fun("gnss_used_snr_avg", gnss_used_snr_avg);
        fun("heading_svs", heading_svs);
        fun("heading_soln_svs", heading_soln_svs);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    friend bool operator==(const ::physical_gnss_sol_result_num_t& lhs, const ::physical_gnss_sol_result_num_t& rhs) noexcept
    {
        return (lhs.gnss_num_sats == rhs.gnss_num_sats) && (lhs.gnss_num_sats_used == rhs.gnss_num_sats_used) && (lhs.gnss_used_snr_avg == rhs.gnss_used_snr_avg) && (lhs.heading_svs == rhs.heading_svs) && (lhs.heading_soln_svs == rhs.heading_soln_svs) && (lhs.timestamp_s == rhs.timestamp_s) && (lhs.timestamp_ns == rhs.timestamp_ns) && (lhs.crc8 == rhs.crc8);
    }
};


#endif // IMPL_TYPE_PHYSICAL_GNSS_SOL_RESULT_NUM_T_H
