/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_PHYSICAL_GNSS_SOL_RESULT_STATUS_T_H
#define IMPL_TYPE_PHYSICAL_GNSS_SOL_RESULT_STATUS_T_H

#include "impl_type_uint8.h"
#include "impl_type_uint64.h"

struct physical_gnss_sol_result_status_t {
    ::UInt8 gnss_postion_type{ 0U };
    ::UInt8 gnss_solution_type{ 0U };
    ::UInt8 heading_position_type{ 0U };
    ::UInt8 heading_solution_type{ 0U };
    ::UInt8 gnss_velocity_type{ 0U };
    ::UInt64 timestamp_s{ 0U };
    ::UInt64 timestamp_ns{ 0U };
    ::UInt8 crc8{ 0U };

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(gnss_postion_type);
        fun(gnss_solution_type);
        fun(heading_position_type);
        fun(heading_solution_type);
        fun(gnss_velocity_type);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(gnss_postion_type);
        fun(gnss_solution_type);
        fun(heading_position_type);
        fun(heading_solution_type);
        fun(gnss_velocity_type);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("gnss_postion_type", gnss_postion_type);
        fun("gnss_solution_type", gnss_solution_type);
        fun("heading_position_type", heading_position_type);
        fun("heading_solution_type", heading_solution_type);
        fun("gnss_velocity_type", gnss_velocity_type);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("gnss_postion_type", gnss_postion_type);
        fun("gnss_solution_type", gnss_solution_type);
        fun("heading_position_type", heading_position_type);
        fun("heading_solution_type", heading_solution_type);
        fun("gnss_velocity_type", gnss_velocity_type);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    friend bool operator==(const ::physical_gnss_sol_result_status_t& lhs, const ::physical_gnss_sol_result_status_t& rhs) noexcept
    {
        return (lhs.gnss_postion_type == rhs.gnss_postion_type) && (lhs.gnss_solution_type == rhs.gnss_solution_type) && (lhs.heading_position_type == rhs.heading_position_type) && (lhs.heading_solution_type == rhs.heading_solution_type) && (lhs.gnss_velocity_type == rhs.gnss_velocity_type) && (lhs.timestamp_s == rhs.timestamp_s) && (lhs.timestamp_ns == rhs.timestamp_ns) && (lhs.crc8 == rhs.crc8);
    }
};


#endif // IMPL_TYPE_PHYSICAL_GNSS_SOL_RESULT_STATUS_T_H
