/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_PHYSICAL_INS_SOL_RESULT_ANGLE_STD_T_H
#define IMPL_TYPE_PHYSICAL_INS_SOL_RESULT_ANGLE_STD_T_H

#include <cfloat>
#include <cmath>
#include "impl_type_double.h"
#include "impl_type_uint64.h"
#include "impl_type_uint8.h"

struct physical_ins_sol_result_angle_std_t {
    ::Double ins_course_angle_std{ 0.0 };
    ::Double ins_yaw_angle_std{ 0.0 };
    ::Double ins_pitch_std{ 0.0 };
    ::Double ins_roll_std{ 0.0 };
    ::UInt64 timestamp_s{ 0U };
    ::UInt64 timestamp_ns{ 0U };
    ::UInt8 crc8{ 0U };

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(ins_course_angle_std);
        fun(ins_yaw_angle_std);
        fun(ins_pitch_std);
        fun(ins_roll_std);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(ins_course_angle_std);
        fun(ins_yaw_angle_std);
        fun(ins_pitch_std);
        fun(ins_roll_std);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("ins_course_angle_std", ins_course_angle_std);
        fun("ins_yaw_angle_std", ins_yaw_angle_std);
        fun("ins_pitch_std", ins_pitch_std);
        fun("ins_roll_std", ins_roll_std);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("ins_course_angle_std", ins_course_angle_std);
        fun("ins_yaw_angle_std", ins_yaw_angle_std);
        fun("ins_pitch_std", ins_pitch_std);
        fun("ins_roll_std", ins_roll_std);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    friend bool operator==(const ::physical_ins_sol_result_angle_std_t& lhs, const ::physical_ins_sol_result_angle_std_t& rhs) noexcept
    {
        return (fabs(static_cast<double>(lhs.ins_course_angle_std - rhs.ins_course_angle_std)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ins_yaw_angle_std - rhs.ins_yaw_angle_std)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ins_pitch_std - rhs.ins_pitch_std)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ins_roll_std - rhs.ins_roll_std)) < DBL_EPSILON) && (lhs.timestamp_s == rhs.timestamp_s) && (lhs.timestamp_ns == rhs.timestamp_ns) && (lhs.crc8 == rhs.crc8);
    }
};


#endif // IMPL_TYPE_PHYSICAL_INS_SOL_RESULT_ANGLE_STD_T_H
