/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_PHYSICAL_INS_SOL_RESULT_STATUS_T_H
#define IMPL_TYPE_PHYSICAL_INS_SOL_RESULT_STATUS_T_H

#include "impl_type_uint8.h"
#include "impl_type_uint64.h"

struct physical_ins_sol_result_status_t {
    ::UInt8 ins_ins_status{ 0U };
    ::UInt8 ins_pos_type{ 0U };
    ::UInt64 timestamp_s{ 0U };
    ::UInt64 timestamp_ns{ 0U };
    ::UInt8 crc8{ 0U };

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(ins_ins_status);
        fun(ins_pos_type);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(ins_ins_status);
        fun(ins_pos_type);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("ins_ins_status", ins_ins_status);
        fun("ins_pos_type", ins_pos_type);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("ins_ins_status", ins_ins_status);
        fun("ins_pos_type", ins_pos_type);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    friend bool operator==(const ::physical_ins_sol_result_status_t& lhs, const ::physical_ins_sol_result_status_t& rhs) noexcept
    {
        return (lhs.ins_ins_status == rhs.ins_ins_status) && (lhs.ins_pos_type == rhs.ins_pos_type) && (lhs.timestamp_s == rhs.timestamp_s) && (lhs.timestamp_ns == rhs.timestamp_ns) && (lhs.crc8 == rhs.crc8);
    }
};


#endif // IMPL_TYPE_PHYSICAL_INS_SOL_RESULT_STATUS_T_H
