/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_PHYSICAL_INS_SOL_RESULT_VEL_T_H
#define IMPL_TYPE_PHYSICAL_INS_SOL_RESULT_VEL_T_H

#include <cfloat>
#include <cmath>
#include "impl_type_double.h"
#include "impl_type_uint64.h"
#include "impl_type_uint8.h"

struct physical_ins_sol_result_vel_t {
    ::Double ins_velocity{ 0.0 };
    ::Double ins_velocity_e{ 0.0 };
    ::Double ins_velocity_n{ 0.0 };
    ::Double ins_velocity_u{ 0.0 };
    ::UInt64 timestamp_s{ 0U };
    ::UInt64 timestamp_ns{ 0U };
    ::UInt8 crc8{ 0U };

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(ins_velocity);
        fun(ins_velocity_e);
        fun(ins_velocity_n);
        fun(ins_velocity_u);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(ins_velocity);
        fun(ins_velocity_e);
        fun(ins_velocity_n);
        fun(ins_velocity_u);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("ins_velocity", ins_velocity);
        fun("ins_velocity_e", ins_velocity_e);
        fun("ins_velocity_n", ins_velocity_n);
        fun("ins_velocity_u", ins_velocity_u);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("ins_velocity", ins_velocity);
        fun("ins_velocity_e", ins_velocity_e);
        fun("ins_velocity_n", ins_velocity_n);
        fun("ins_velocity_u", ins_velocity_u);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    friend bool operator==(const ::physical_ins_sol_result_vel_t& lhs, const ::physical_ins_sol_result_vel_t& rhs) noexcept
    {
        return (fabs(static_cast<double>(lhs.ins_velocity - rhs.ins_velocity)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ins_velocity_e - rhs.ins_velocity_e)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ins_velocity_n - rhs.ins_velocity_n)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.ins_velocity_u - rhs.ins_velocity_u)) < DBL_EPSILON) && (lhs.timestamp_s == rhs.timestamp_s) && (lhs.timestamp_ns == rhs.timestamp_ns) && (lhs.crc8 == rhs.crc8);
    }
};


#endif // IMPL_TYPE_PHYSICAL_INS_SOL_RESULT_VEL_T_H
