/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_PHYSICAL_MESSAGE_HS_CAN_100_T_H
#define IMPL_TYPE_PHYSICAL_MESSAGE_HS_CAN_100_T_H

#include "impl_type_uint8.h"
#include "impl_type_uint64.h"

struct physical_message_hs_can_100_t {
    ::UInt8 pas_mode{ 0U };
    ::UInt8 pas_warn_tone{ 0U };
    ::UInt8 pas_rl_distance{ 0U };
    ::UInt8 pas_rl_mid_distance{ 0U };
    ::UInt8 pas_rr_mid_distance{ 0U };
    ::UInt8 pas_rr_distance{ 0U };
    ::UInt64 timestamp_s{ 0U };
    ::UInt64 timestamp_ns{ 0U };
    ::UInt8 crc8{ 0U };

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(pas_mode);
        fun(pas_warn_tone);
        fun(pas_rl_distance);
        fun(pas_rl_mid_distance);
        fun(pas_rr_mid_distance);
        fun(pas_rr_distance);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(pas_mode);
        fun(pas_warn_tone);
        fun(pas_rl_distance);
        fun(pas_rl_mid_distance);
        fun(pas_rr_mid_distance);
        fun(pas_rr_distance);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("pas_mode", pas_mode);
        fun("pas_warn_tone", pas_warn_tone);
        fun("pas_rl_distance", pas_rl_distance);
        fun("pas_rl_mid_distance", pas_rl_mid_distance);
        fun("pas_rr_mid_distance", pas_rr_mid_distance);
        fun("pas_rr_distance", pas_rr_distance);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("pas_mode", pas_mode);
        fun("pas_warn_tone", pas_warn_tone);
        fun("pas_rl_distance", pas_rl_distance);
        fun("pas_rl_mid_distance", pas_rl_mid_distance);
        fun("pas_rr_mid_distance", pas_rr_mid_distance);
        fun("pas_rr_distance", pas_rr_distance);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    friend bool operator==(const ::physical_message_hs_can_100_t& lhs, const ::physical_message_hs_can_100_t& rhs) noexcept
    {
        return (lhs.pas_mode == rhs.pas_mode) && (lhs.pas_warn_tone == rhs.pas_warn_tone) && (lhs.pas_rl_distance == rhs.pas_rl_distance) && (lhs.pas_rl_mid_distance == rhs.pas_rl_mid_distance) && (lhs.pas_rr_mid_distance == rhs.pas_rr_mid_distance) && (lhs.pas_rr_distance == rhs.pas_rr_distance) && (lhs.timestamp_s == rhs.timestamp_s) && (lhs.timestamp_ns == rhs.timestamp_ns) && (lhs.crc8 == rhs.crc8);
    }
};


#endif // IMPL_TYPE_PHYSICAL_MESSAGE_HS_CAN_100_T_H
