/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_PHYSICAL_MESSAGE_HS_CAN_101_T_H
#define IMPL_TYPE_PHYSICAL_MESSAGE_HS_CAN_101_T_H

#include "impl_type_uint8.h"
#include "impl_type_uint64.h"

struct physical_message_hs_can_101_t {
    ::UInt8 pas_fl_distance{ 0U };
    ::UInt8 pas_fl_mid_distance{ 0U };
    ::UInt8 pas_fr_mid_distance{ 0U };
    ::UInt8 pas_fr_distance{ 0U };
    ::UInt8 pas_rl_sns_err_flag{ 0U };
    ::UInt8 pas_rl_mid_sns_err_flag{ 0U };
    ::UInt8 pas_rr_mid_sns_err_flag{ 0U };
    ::UInt8 pas_rr_sns_err_flag{ 0U };
    ::UInt8 pas_fl_sns_err_flag{ 0U };
    ::UInt8 pas_fl_mid_sns_err_flag{ 0U };
    ::UInt8 pas_fr_mid_sns_err_flag{ 0U };
    ::UInt8 pas_fr_sns_err_flag{ 0U };
    ::UInt64 timestamp_s{ 0U };
    ::UInt64 timestamp_ns{ 0U };
    ::UInt8 crc8{ 0U };

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(pas_fl_distance);
        fun(pas_fl_mid_distance);
        fun(pas_fr_mid_distance);
        fun(pas_fr_distance);
        fun(pas_rl_sns_err_flag);
        fun(pas_rl_mid_sns_err_flag);
        fun(pas_rr_mid_sns_err_flag);
        fun(pas_rr_sns_err_flag);
        fun(pas_fl_sns_err_flag);
        fun(pas_fl_mid_sns_err_flag);
        fun(pas_fr_mid_sns_err_flag);
        fun(pas_fr_sns_err_flag);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(pas_fl_distance);
        fun(pas_fl_mid_distance);
        fun(pas_fr_mid_distance);
        fun(pas_fr_distance);
        fun(pas_rl_sns_err_flag);
        fun(pas_rl_mid_sns_err_flag);
        fun(pas_rr_mid_sns_err_flag);
        fun(pas_rr_sns_err_flag);
        fun(pas_fl_sns_err_flag);
        fun(pas_fl_mid_sns_err_flag);
        fun(pas_fr_mid_sns_err_flag);
        fun(pas_fr_sns_err_flag);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("pas_fl_distance", pas_fl_distance);
        fun("pas_fl_mid_distance", pas_fl_mid_distance);
        fun("pas_fr_mid_distance", pas_fr_mid_distance);
        fun("pas_fr_distance", pas_fr_distance);
        fun("pas_rl_sns_err_flag", pas_rl_sns_err_flag);
        fun("pas_rl_mid_sns_err_flag", pas_rl_mid_sns_err_flag);
        fun("pas_rr_mid_sns_err_flag", pas_rr_mid_sns_err_flag);
        fun("pas_rr_sns_err_flag", pas_rr_sns_err_flag);
        fun("pas_fl_sns_err_flag", pas_fl_sns_err_flag);
        fun("pas_fl_mid_sns_err_flag", pas_fl_mid_sns_err_flag);
        fun("pas_fr_mid_sns_err_flag", pas_fr_mid_sns_err_flag);
        fun("pas_fr_sns_err_flag", pas_fr_sns_err_flag);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("pas_fl_distance", pas_fl_distance);
        fun("pas_fl_mid_distance", pas_fl_mid_distance);
        fun("pas_fr_mid_distance", pas_fr_mid_distance);
        fun("pas_fr_distance", pas_fr_distance);
        fun("pas_rl_sns_err_flag", pas_rl_sns_err_flag);
        fun("pas_rl_mid_sns_err_flag", pas_rl_mid_sns_err_flag);
        fun("pas_rr_mid_sns_err_flag", pas_rr_mid_sns_err_flag);
        fun("pas_rr_sns_err_flag", pas_rr_sns_err_flag);
        fun("pas_fl_sns_err_flag", pas_fl_sns_err_flag);
        fun("pas_fl_mid_sns_err_flag", pas_fl_mid_sns_err_flag);
        fun("pas_fr_mid_sns_err_flag", pas_fr_mid_sns_err_flag);
        fun("pas_fr_sns_err_flag", pas_fr_sns_err_flag);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    friend bool operator==(const ::physical_message_hs_can_101_t& lhs, const ::physical_message_hs_can_101_t& rhs) noexcept
    {
        return (lhs.pas_fl_distance == rhs.pas_fl_distance) && (lhs.pas_fl_mid_distance == rhs.pas_fl_mid_distance) && (lhs.pas_fr_mid_distance == rhs.pas_fr_mid_distance) && (lhs.pas_fr_distance == rhs.pas_fr_distance) && (lhs.pas_rl_sns_err_flag == rhs.pas_rl_sns_err_flag) && (lhs.pas_rl_mid_sns_err_flag == rhs.pas_rl_mid_sns_err_flag) && (lhs.pas_rr_mid_sns_err_flag == rhs.pas_rr_mid_sns_err_flag) && (lhs.pas_rr_sns_err_flag == rhs.pas_rr_sns_err_flag) && (lhs.pas_fl_sns_err_flag == rhs.pas_fl_sns_err_flag) && (lhs.pas_fl_mid_sns_err_flag == rhs.pas_fl_mid_sns_err_flag) && (lhs.pas_fr_mid_sns_err_flag == rhs.pas_fr_mid_sns_err_flag) && (lhs.pas_fr_sns_err_flag == rhs.pas_fr_sns_err_flag) && (lhs.timestamp_s == rhs.timestamp_s) && (lhs.timestamp_ns == rhs.timestamp_ns) && (lhs.crc8 == rhs.crc8);
    }
};


#endif // IMPL_TYPE_PHYSICAL_MESSAGE_HS_CAN_101_T_H
