/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_PHYSICAL_VCU_INFO_2_T_H
#define IMPL_TYPE_PHYSICAL_VCU_INFO_2_T_H

#include <cfloat>
#include <cmath>
#include "impl_type_double.h"
#include "impl_type_uint8.h"
#include "impl_type_uint64.h"

struct physical_vcu_info_2_t {
    ::Double soc1{ 0.0 };
    ::Double soc2{ 0.0 };
    ::UInt8 collision_status{ 0U };
    ::UInt8 motor_direction{ 0U };
    ::UInt64 timestamp_s{ 0U };
    ::UInt64 timestamp_ns{ 0U };
    ::UInt8 crc8{ 0U };

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(soc1);
        fun(soc2);
        fun(collision_status);
        fun(motor_direction);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(soc1);
        fun(soc2);
        fun(collision_status);
        fun(motor_direction);
        fun(timestamp_s);
        fun(timestamp_ns);
        fun(crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("soc1", soc1);
        fun("soc2", soc2);
        fun("collision_status", collision_status);
        fun("motor_direction", motor_direction);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("soc1", soc1);
        fun("soc2", soc2);
        fun("collision_status", collision_status);
        fun("motor_direction", motor_direction);
        fun("timestamp_s", timestamp_s);
        fun("timestamp_ns", timestamp_ns);
        fun("crc8", crc8);
    }

    friend bool operator==(const ::physical_vcu_info_2_t& lhs, const ::physical_vcu_info_2_t& rhs) noexcept
    {
        return (fabs(static_cast<double>(lhs.soc1 - rhs.soc1)) < DBL_EPSILON) && (fabs(static_cast<double>(lhs.soc2 - rhs.soc2)) < DBL_EPSILON) && (lhs.collision_status == rhs.collision_status) && (lhs.motor_direction == rhs.motor_direction) && (lhs.timestamp_s == rhs.timestamp_s) && (lhs.timestamp_ns == rhs.timestamp_ns) && (lhs.crc8 == rhs.crc8);
    }
};


#endif // IMPL_TYPE_PHYSICAL_VCU_INFO_2_T_H
