/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef PERCEPTION_IMPL_TYPE_SENSORHEADER_H
#define PERCEPTION_IMPL_TYPE_SENSORHEADER_H

#include "impl_type_int32.h"
#include "impl_type_uint16.h"

namespace perception {
struct SensorHeader {
    ::Int32 stampHigh{ 0 };
    ::UInt16 sensor_name{ 0U };
    ::Int32 stampLow{ 0 };

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(stampHigh);
        fun(sensor_name);
        fun(stampLow);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(stampHigh);
        fun(sensor_name);
        fun(stampLow);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("stampHigh", stampHigh);
        fun("sensor_name", sensor_name);
        fun("stampLow", stampLow);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("stampHigh", stampHigh);
        fun("sensor_name", sensor_name);
        fun("stampLow", stampLow);
    }

    friend bool operator==(const ::perception::SensorHeader& lhs, const ::perception::SensorHeader& rhs) noexcept
    {
        return (lhs.stampHigh == rhs.stampHigh) && (lhs.sensor_name == rhs.sensor_name) && (lhs.stampLow == rhs.stampLow);
    }
};
} // namespace perception


#endif // PERCEPTION_IMPL_TYPE_SENSORHEADER_H
